//
// Socket server to handle web access
//

var express = require('express'),
	io = require('socket.io');

var app = express.createServer();

app.configure(function() {
	app.use(express.staticProvider(__dirname + '/static'));
});

var socket = io.listen(app);

//
// Tail process to monitor serial output
//

var spawn = require('child_process').spawn,
	serial = spawn('tail', ['-n', '0', '-f', 'serial.log']);

var buffer = "";
serial.stdout.on('data', function(data) {
	if (data == "\n") {
		socket.broadcast(buffer);
		buffer = "";
	}
	else
		buffer += data;
});

serial.stderr.on('data', function(data) {
	console.log('serial err: ' + data);
});

serial.on('exit', function(code, signal) {
	console.log('serial exited with ' + code + "\n");
});

process.on('SIGINT', function() {
	serial.kill();
	process.exit(0);
});

//
// Start listening for connections
//
app.listen(3000);
